package de.ullisroboterseite.urstinywebdb;

import java.io.*;
import java.util.*;
import org.json.simple.*;
import org.json.simple.parser.JSONParser;

class UrsTinyWebDataBase {
	Map<String, String> map = new HashMap<String, String>();
	
	private boolean _isDirty = false;
	
	public boolean isDirty (){
		return _isDirty;
	}

	synchronized public Boolean initialize(String fileName) {
		JSONParser parser = new JSONParser();

		try {
			JSONObject dbIn = (JSONObject) parser.parse(new FileReader(fileName));
			@SuppressWarnings("unchecked")
			Map<String, String> map1 = (HashMap<String, String>) dbIn;
			map = map1;
		} catch (Exception e) {
			return false;
		}
		_isDirty = false;
		return true;
	}

	synchronized public void persist(String fileName) throws IOException {
		JSONObject db = new JSONObject(map);
		File file = new File(fileName);
			FileWriter writer = new FileWriter(file);
			db.writeJSONString(writer);

			writer.close();
			_isDirty = false;
	}

	synchronized public void storeValue(String key, String value) {
		map.put(key, value);
		_isDirty = true;
	}

	synchronized public String getValue(String key) {
		return map.get(key);
	}

	synchronized public Boolean deleteValue(String key) {
		if (!map.containsKey(key))
			return false;
		map.remove(key);
		_isDirty = true;
		return true;
	}
	
	synchronized public String getAll() {
		JSONObject db = new JSONObject(map);
		return db.toJSONString();
	}
}